//+------------------------------------------------------------------+
//|                                                     SubChart.mq4 |
//|                                                           mladen |
//|                                               mladenfx@gmail.com |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 DimGray
#property indicator_color2 DimGray
#property indicator_color3 Red
#property indicator_color4 Green
#property indicator_color5 DimGray
#property indicator_style5 STYLE_DOT

//
//
//
//
//

extern string    ForSymbol  = "";
extern string    TimeFrame  = "Current time frame";
extern string    ChartID    = "1";
extern int       FromRight  = 110;
extern int       Width      = 130;
extern bool      UpperHalf  = false;
extern color     FrameColor = DimGray;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];

int    timeFrame;
string forSymbol;
string title;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,buffer5);

   //
   //
   //
   //
   //
   
   forSymbol = ForSymbol;
   if (forSymbol == "")
       forSymbol = Symbol(); 
       forSymbol = StringUpperCase(forSymbol);
          if (iClose(forSymbol,timeFrame,0) == 0) forSymbol = Symbol();
          
   //
   //
   //
   //
                   
   timeFrame = StringToTimeFrame(TimeFrame);  
   title     = forSymbol+" - "+TimeFrameToString(timeFrame);
   return(0);
}

//
//
//
//
//

int deinit()
{
   switch(UninitializeReason())
   {
        case REASON_RECOMPILE:
        case REASON_PARAMETERS:
        case REASON_ACCOUNT:
             break;
        case REASON_REMOVE:
        case REASON_CHARTCHANGE:
        case REASON_CHARTCLOSE:
             ObjectDelete(ChartID);
             ObjectDelete(ChartID+"frame");
             break;
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   double maxValue = iHigh(forSymbol,timeFrame,iHighest(forSymbol,timeFrame,MODE_HIGH,Width-2,0));
   double minValue =  iLow(forSymbol,timeFrame, iLowest(forSymbol,timeFrame,MODE_LOW ,Width-2,0));
   double range    = maxValue-minValue;
   
   //
   //
   //
   //
   //
   
   double high;
   double low;
      checkFrame(high,low);
         SetIndexShift(0,-(FromRight+1)); 
         SetIndexShift(1,-(FromRight+1)); 
         SetIndexShift(2,-(FromRight+1)); 
         SetIndexShift(3,-(FromRight+1)); 
         SetIndexShift(4,-(FromRight+1));
      
      //
      //
      //
      //
      //
      
      double coef = (high-low)/range;
      for (int i=0; i<Width-1; i++)
      {
         double priceO =  iOpen(forSymbol,timeFrame,i);
         double priceC = iClose(forSymbol,timeFrame,i);
         double priceH =  iHigh(forSymbol,timeFrame,i);
         double priceL =   iLow(forSymbol,timeFrame,i);
            buffer1[i] = low+(priceH-minValue)*coef;
            buffer2[i] = low+(priceL-minValue)*coef;
            buffer3[i] = low+(priceO-minValue)*coef;
            buffer4[i] = low+(priceC-minValue)*coef;
            buffer5[i] = buffer4[0];
      }
      while(i < Bars && buffer1[i] != EMPTY_VALUE)
      {
            buffer1[i] = EMPTY_VALUE;
            buffer2[i] = EMPTY_VALUE;
            buffer3[i] = EMPTY_VALUE;
            buffer4[i] = EMPTY_VALUE;
            buffer5[i] = EMPTY_VALUE;
            i++;
      }
   return(0);
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

void checkFrame(double& high, double& low)
{
   string name = ChartID+"frame";
          
   //
   //
   //
   //
   //
     
   int firstBar = MathMin(WindowFirstVisibleBar(),WindowBarsPerChart());
   if (UpperHalf)
   {      
      high = iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,firstBar,0))-Point;
      low  = (iLow(NULL,0, iLowest(NULL,0,MODE_LOW ,firstBar,0))+high)/2+Point;
   }
   else
   {
      low  =   iLow(NULL,0, iLowest(NULL,0,MODE_LOW ,firstBar,0))+Point;
      high = (iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,firstBar,0))+low)/2-Point;
   }      
      if (ObjectFind(name) == -1)
         {
            ObjectCreate(name,OBJ_RECTANGLE,0,0,0,0,0);
               ObjectSet(name,OBJPROP_COLOR,FrameColor);
               ObjectSet(name,OBJPROP_BACK,false);
         }     
   
      //
      //
      //
      //
      //
      
      datetime rightBorder = Time[FromRight];
      datetime leftBorder  = Time[FromRight+Width];
      if (FromRight<0)
      {
         rightBorder = Time[0]-Period()*60*FromRight;
         if ((FromRight+Width) > 0)
               leftBorder = Time[FromRight+Width];
         else  leftBorder = Time[0]-Period()*60*(FromRight+Width);
      }
      else
      {
         ObjectSet(name,OBJPROP_TIME1,Time[FromRight]);
         ObjectSet(name,OBJPROP_TIME2,Time[FromRight+Width]);
      }      

   //
   //
   //
   //
   //
   
      ObjectSet(name,OBJPROP_TIME1,rightBorder);
      ObjectSet(name,OBJPROP_TIME2,leftBorder);
      ObjectSet(name,OBJPROP_PRICE1,high+Point);
      ObjectSet(name,OBJPROP_PRICE2,low -Point);

   //
   //
   //
   //
   //
   
   name = ChartID;
      if (ObjectFind(name) == -1)
               ObjectCreate(name,OBJ_TEXT,0,0,0);
               ObjectSet(name,OBJPROP_TIME1,rightBorder-Width/2*Period()*60);
               ObjectSet(name,OBJPROP_PRICE1,high);
               ObjectSetText(name,title+" : "+DoubleToStr(iClose(forSymbol,timeFrame,0),MarketInfo(forSymbol,MODE_DIGITS)),10,"Arial bold",YellowGreen);
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

int StringToTimeFrame(string tfs)
{
   int tf=Period();
       tfs = StringTrimLeft(StringTrimRight(StringUpperCase(tfs)));
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
  return(tf);
}
string TimeFrameToString(int tf)
{
   string tfs="";
   
 //  if (tf!=Period())
      switch(tf) {
         case PERIOD_M1:  tfs="M1"  ; break;
         case PERIOD_M5:  tfs="M5"  ; break;
         case PERIOD_M15: tfs="M15" ; break;
         case PERIOD_M30: tfs="M30" ; break;
         case PERIOD_H1:  tfs="H1"  ; break;
         case PERIOD_H4:  tfs="H4"  ; break;
         case PERIOD_D1:  tfs="D1"  ; break;
         case PERIOD_W1:  tfs="W1"  ; break;
         case PERIOD_MN1: tfs="MN1";
      }
   return(tfs);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   int lenght = StringLen(str) - 1;
   int char;
   
   while(lenght >= 0)
   {
      char = StringGetChar(str, lenght);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  str = StringSetChar(str, lenght, char - 32);
         else 
              if(char > -33 && char < 0)
                  str = StringSetChar(str, lenght, char + 224);
      lenght--;
   }
   return(str);
}